diff --git a/src/include/c.h b/src/include/c.h
index d70ed84ac5..12ff782a63 100644
--- a/src/include/c.h
+++ b/src/include/c.h
@@ -800,7 +800,12 @@ typedef NameData *Name;
 #include <assert.h>
 #define Assert(p) assert(p)
 #define AssertMacro(p)	((void) assert(p))
-#define AssertPointerAlignment(ptr, bndr)	((void)true)
+
+/*
+ * Check that `ptr' is `bndr' aligned.
+ */
+#define AssertPointerAlignment(ptr, bndr) \
+	Assert(TYPEALIGN(bndr, (uintptr_t)(ptr)) == (uintptr_t)(ptr))
 
 #else							/* USE_ASSERT_CHECKING && !FRONTEND */
 
